import { Cookie } from "../cookie";
import { InternalOptions } from "src/lib/types";
/**
 * Returns `code_challenge` and `code_challenge_method`
 * and saves them in a cookie.
 * @type {import("src/lib/types").InternalOptions}
 * @returns {Promise<undefined | {
 *  code_challenge: string
 *  code_challenge_method: "S256"
 *  cookie: import("../cookie").Cookie
 * }>
 */
declare type PKCE = Promise<undefined | {
    code_challenge: string;
    code_challenge_method: "S256";
    cookie: Cookie;
}>;
export declare function createPKCE(options: InternalOptions<"oauth">): PKCE;
/**
 * Returns code_verifier if provider uses PKCE,
 * and clears the container cookie afterwards.
 */
export declare function usePKCECodeVerifier(codeVerifier: string | undefined, options: InternalOptions<"oauth">): Promise<{
    codeVerifier: string;
    cookie: Cookie;
} | undefined>;
export {};
